#!/usr/bin/perl
#####################################################################################################
#Copyright (C) 2002 by Adiscon GmbH * http://www.adiscon.com
#
#This software can be distributed freely and used without cost, as long as this copyright notice
#and disclaimer is retained unmodified. This script is free. Use it at your own risk. Adiscon will
#not be responsible for any problem you might encounter.
#
#To run this script, SendMail is used which is part of the Unix envirement system.
#####################################################################################################
use CGI qw/:standard/;
use CGI::Carp 'fatalsToBrowser';

######## DO NOT BUFFER ##############################################################################
$| = 1; 
#####################################################################################################

$CGIObject = new CGI;
#####################################################################################################
# Path to sendmail:
$mailprog="/usr/sbin/sendmail";
#
# Recipient
$recipient="youremail\@yourdomain.adiscon.com";
#
#Read all variables
$email		= $CGIObject->param('Email');
$firstname	= $CGIObject->param('FirstName');
$lastname	= $CGIObject->param('LastName');
$action		= $CGIObject->param('action');
$Newsletter1	= $CGIObject->param('Newsletter1'); 
$Newsletter2	= $CGIObject->param('Newsletter2'); 
$Newsletter3	= $CGIObject->param('Newsletter3'); 
#####################################################################################################


#If the user wants to Subscribe.
if ($action eq "Subscribe")
{
	print $CGIObject->header;

	if ($Newsletter1 ne ""){ &SendSubscribeEmail("Newsletter 1");}
	if ($Newsletter2 ne ""){ &SendSubscribeEmail("Newsletter 2");}
	if ($Newsletter3 ne ""){ &SendSubscribeEmail("Newsletter 3");}

	&PrintSubscribedForm();
}
#If the user wants to Unsubscribe.
elsif($action eq "Unsubscribe")
{
	print $CGIObject->header;

	if ($Newsletter1 ne ""){ &SendUnsubscribeEmail("Newsletter 1");}
	if ($Newsletter2 ne ""){ &SendUnsubscribeEmail("Newsletter 2");}
	if ($Newsletter3 ne ""){ &SendUnsubscribeEmail("Newsletter 3");}

	&PrintUnsubscribedForm();
}
#Prints the defaultform
else
{
	&PrintDefaultForm();
}

#Call the Splitterfunction
#&SendNewsMergeEmail();

#-------------------------------------------------------
#Function that sends the Subscribe Email
sub SendSubscribeEmail {
	#Comment out for debugging
	#print "DEBUG Sending Subscribe Email for: $_[0]<BR>";

	open (MAIL, "| $mailprog -t -oi") || die "Can't open $mailprog";
	print MAIL "To: $recipient\n";
	print MAIL "Reply-to: $recipient\n";
	print MAIL "From: $email ($firstname $lastname)\n";
	print MAIL "Subject: NewsMerge subscribe mail\n";
	print MAIL "Message:\n\n";

	print MAIL "subscribe $_[0]\n";
	print MAIL "firstname $firstname\n";
	print MAIL "lastname $lastname\n";

	close (MAIL);
}

#-------------------------------------------------------
#Function that sends the Unsubscribe Email
sub SendUnsubscribeEmail {
	#Comment out for debugging
	#print "DEBUG Sending Unsubscribe Email for: $_[0]<BR>";

	open (MAIL, "| $mailprog -t -oi") || die "Can't open $mailprog";
	print MAIL "To: $recipient\n";
	print MAIL "Reply-to: $recipient\n";
	print MAIL "From: $email ($firstname $lastname)\n";
	print MAIL "Subject: NewsMerge subscribe mail\n";
	print MAIL "Message:\n\n";

	print MAIL "unsubscribe $_[0]\n";
	print MAIL "firstname $firstname\n";
	print MAIL "lastname $lastname\n";

	close (MAIL);
}

#-------------------------------------------------------
#Function that prints the defaultform
sub PrintDefaultForm {
	print $CGIObject->header;

	print<<HTML;
	<html>
	<head>
	<title>NewsMerge Subscribe / Unsubscibe site</title>
	</head>

	<body>
	<center><B>NewsMerge Subscribe / Unsubscibe site</B></center>
	<BR>
	<form method="POST" action="">
		<B>Email:</B>		<input type="text" name="Email">
		<BR>
		<B>FirstName: </B>	<input type="text" name="FirstName">
		<BR>
		<B>LastName: </B>	<input type="text" name="LastName">
		<BR>
		Newsletter:
		<BR>
		<input type="checkbox" name="Newsletter1" value="1" checked>Newsletter 1<BR>
		<input type="checkbox" name="Newsletter2" value="1" checked>Newsletter 2<BR>
		<input type="checkbox" name="Newsletter3" value="1" checked>Newsletter 3<BR>
		<BR>
		<input type="submit" value="Subscribe" name="action">
		<input type="submit" value="Unsubscribe" name="action">
	</form>

	</body>
	</html>
HTML
}

sub PrintSubscribedForm {
	print<<HTML;
	<html>
	<head>
	<title>Thank you for subscribing</title>
	</head>

	<body>
	<center><B>Thank you for subscribing</B></center>
	</body>
	</html>
HTML
}

sub PrintUnsubscribedForm {
	print<<HTML;
	<html>
	<head>
	<title>Thank you for subscribing</title>
	</head>

	<body>
	<center><B>Thank you for subscribing</B></center>
	</body>
	</html>
HTML
}